config/routes.rb
Rails.application.routes.draw do
  resources :laptops
  resources :branches
  resources :employees
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/branch.rb
class Branch < ApplicationRecord
end

app/models/employee.rb
class Employee < ApplicationRecord
end

app/models/laptop.rb
class Laptop < ApplicationRecord
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/branches_controller.rb
class BranchesController < ApplicationController
  before_action :set_branch, only: [:show, :edit, :update, :destroy]

  # GET /branches
  # GET /branches.json
  def index
    @branches = Branch.all
  end

  # GET /branches/1
  # GET /branches/1.json
  def show
  end

  # GET /branches/new
  def new
    @branch = Branch.new
  end

  # GET /branches/1/edit
  def edit
  end

  # POST /branches
  # POST /branches.json
  def create
    @branch = Branch.new(branch_params)

    respond_to do |format|
      if @branch.save
        format.html { redirect_to @branch, notice: 'Branch was successfully created.' }
        format.json { render :show, status: :created, location: @branch }
      else
        format.html { render :new }
        format.json { render json: @branch.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /branches/1
  # PATCH/PUT /branches/1.json
  def update
    respond_to do |format|
      if @branch.update(branch_params)
        format.html { redirect_to @branch, notice: 'Branch was successfully updated.' }
        format.json { render :show, status: :ok, location: @branch }
      else
        format.html { render :edit }
        format.json { render json: @branch.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /branches/1
  # DELETE /branches/1.json
  def destroy
    @branch.destroy
    respond_to do |format|
      format.html { redirect_to branches_url, notice: 'Branch was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_branch
      @branch = Branch.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def branch_params
      params.require(:branch).permit(:address, :phone)
    end
end

app/controllers/employees_controller.rb
class EmployeesController < ApplicationController
  before_action :set_employee, only: [:show, :edit, :update, :destroy]

  # GET /employees
  # GET /employees.json
  def index
    @employees = Employee.all
  end

  # GET /employees/1
  # GET /employees/1.json
  def show
  end

  # GET /employees/new
  def new
    @employee = Employee.new
  end

  # GET /employees/1/edit
  def edit
  end

  # POST /employees
  # POST /employees.json
  def create
    @employee = Employee.new(employee_params)

    respond_to do |format|
      if @employee.save
        format.html { redirect_to @employee, notice: 'Employee was successfully created.' }
        format.json { render :show, status: :created, location: @employee }
      else
        format.html { render :new }
        format.json { render json: @employee.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /employees/1
  # PATCH/PUT /employees/1.json
  def update
    respond_to do |format|
      if @employee.update(employee_params)
        format.html { redirect_to @employee, notice: 'Employee was successfully updated.' }
        format.json { render :show, status: :ok, location: @employee }
      else
        format.html { render :edit }
        format.json { render json: @employee.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /employees/1
  # DELETE /employees/1.json
  def destroy
    @employee.destroy
    respond_to do |format|
      format.html { redirect_to employees_url, notice: 'Employee was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_employee
      @employee = Employee.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def employee_params
      params.require(:employee).permit(:name, :address, :salary, :branch_id)
    end
end

app/controllers/laptops_controller.rb
class LaptopsController < ApplicationController
  before_action :set_laptop, only: [:show, :edit, :update, :destroy]

  # GET /laptops
  # GET /laptops.json
  def index
    @laptops = Laptop.all
  end

  # GET /laptops/1
  # GET /laptops/1.json
  def show
  end

  # GET /laptops/new
  def new
    @laptop = Laptop.new
  end

  # GET /laptops/1/edit
  def edit
  end

  # POST /laptops
  # POST /laptops.json
  def create
    @laptop = Laptop.new(laptop_params)

    respond_to do |format|
      if @laptop.save
        format.html { redirect_to @laptop, notice: 'Laptop was successfully created.' }
        format.json { render :show, status: :created, location: @laptop }
      else
        format.html { render :new }
        format.json { render json: @laptop.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /laptops/1
  # PATCH/PUT /laptops/1.json
  def update
    respond_to do |format|
      if @laptop.update(laptop_params)
        format.html { redirect_to @laptop, notice: 'Laptop was successfully updated.' }
        format.json { render :show, status: :ok, location: @laptop }
      else
        format.html { render :edit }
        format.json { render json: @laptop.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /laptops/1
  # DELETE /laptops/1.json
  def destroy
    @laptop.destroy
    respond_to do |format|
      format.html { redirect_to laptops_url, notice: 'Laptop was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_laptop
      @laptop = Laptop.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def laptop_params
      params.require(:laptop).permit(:brand, :tipe, :employee_id, :is_active)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/branches_helper.rb
module BranchesHelper
end

app/helpers/employees_helper.rb
module EmployeesHelper
end

app/helpers/laptops_helper.rb
module LaptopsHelper
end

app/views/branches/_form.html.erb
<%= form_with(model: branch, local: true) do |form| %>
  <% if branch.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(branch.errors.count, "error") %> prohibited this branch from being saved:</h2>

      <ul>
        <% branch.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :address %>
    <%= form.text_area :address %>
  </div>

  <div class="field">
    <%= form.label :phone %>
    <%= form.text_field :phone %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/branches/edit.html.erb
<h1>Editing Branch</h1>

<%= render 'form', branch: @branch %>

<%= link_to 'Show', @branch %> |
<%= link_to 'Back', branches_path %>

app/views/branches/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Branches</h1>

<table>
  <thead>
    <tr>
      <th>Address</th>
      <th>Phone</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @branches.each do |branch| %>
      <tr>
        <td><%= branch.address %></td>
        <td><%= branch.phone %></td>
        <td><%= link_to 'Show', branch %></td>
        <td><%= link_to 'Edit', edit_branch_path(branch) %></td>
        <td><%= link_to 'Destroy', branch, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Branch', new_branch_path %>

app/views/branches/new.html.erb
<h1>New Branch</h1>

<%= render 'form', branch: @branch %>

<%= link_to 'Back', branches_path %>

app/views/branches/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Address:</strong>
  <%= @branch.address %>
</p>

<p>
  <strong>Phone:</strong>
  <%= @branch.phone %>
</p>

<%= link_to 'Edit', edit_branch_path(@branch) %> |
<%= link_to 'Back', branches_path %>

app/views/employees/_form.html.erb
<%= form_with(model: employee, local: true) do |form| %>
  <% if employee.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(employee.errors.count, "error") %> prohibited this employee from being saved:</h2>

      <ul>
        <% employee.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :name %>
    <%= form.text_field :name %>
  </div>

  <div class="field">
    <%= form.label :address %>
    <%= form.text_area :address %>
  </div>

  <div class="field">
    <%= form.label :salary %>
    <%= form.text_field :salary %>
  </div>

  <div class="field">
    <%= form.label :branch_id %>
    <%= form.number_field :branch_id %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/employees/edit.html.erb
<h1>Editing Employee</h1>

<%= render 'form', employee: @employee %>

<%= link_to 'Show', @employee %> |
<%= link_to 'Back', employees_path %>

app/views/employees/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Employees</h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th>Address</th>
      <th>Salary</th>
      <th>Branch</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @employees.each do |employee| %>
      <tr>
        <td><%= employee.name %></td>
        <td><%= employee.address %></td>
        <td><%= employee.salary %></td>
        <td><%= employee.branch_id %></td>
        <td><%= link_to 'Show', employee %></td>
        <td><%= link_to 'Edit', edit_employee_path(employee) %></td>
        <td><%= link_to 'Destroy', employee, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Employee', new_employee_path %>

app/views/employees/new.html.erb
<h1>New Employee</h1>

<%= render 'form', employee: @employee %>

<%= link_to 'Back', employees_path %>

app/views/employees/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @employee.name %>
</p>

<p>
  <strong>Address:</strong>
  <%= @employee.address %>
</p>

<p>
  <strong>Salary:</strong>
  <%= @employee.salary %>
</p>

<p>
  <strong>Branch:</strong>
  <%= @employee.branch_id %>
</p>

<%= link_to 'Edit', edit_employee_path(@employee) %> |
<%= link_to 'Back', employees_path %>

app/views/laptops/_form.html.erb
<%= form_with(model: laptop, local: true) do |form| %>
  <% if laptop.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(laptop.errors.count, "error") %> prohibited this laptop from being saved:</h2>

      <ul>
        <% laptop.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :brand %>
    <%= form.text_field :brand %>
  </div>

  <div class="field">
    <%= form.label :tipe %>
    <%= form.text_field :tipe %>
  </div>

  <div class="field">
    <%= form.label :employee_id %>
    <%= form.number_field :employee_id %>
  </div>

  <div class="field">
    <%= form.label :is_active %>
    <%= form.number_field :is_active %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/laptops/edit.html.erb
<h1>Editing Laptop</h1>

<%= render 'form', laptop: @laptop %>

<%= link_to 'Show', @laptop %> |
<%= link_to 'Back', laptops_path %>

app/views/laptops/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Laptops</h1>

<table>
  <thead>
    <tr>
      <th>Brand</th>
      <th>Tipe</th>
      <th>Employee</th>
      <th>Is active</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @laptops.each do |laptop| %>
      <tr>
        <td><%= laptop.brand %></td>
        <td><%= laptop.tipe %></td>
        <td><%= laptop.employee_id %></td>
        <td><%= laptop.is_active %></td>
        <td><%= link_to 'Show', laptop %></td>
        <td><%= link_to 'Edit', edit_laptop_path(laptop) %></td>
        <td><%= link_to 'Destroy', laptop, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Laptop', new_laptop_path %>

app/views/laptops/new.html.erb
<h1>New Laptop</h1>

<%= render 'form', laptop: @laptop %>

<%= link_to 'Back', laptops_path %>

app/views/laptops/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Brand:</strong>
  <%= @laptop.brand %>
</p>

<p>
  <strong>Tipe:</strong>
  <%= @laptop.tipe %>
</p>

<p>
  <strong>Employee:</strong>
  <%= @laptop.employee_id %>
</p>

<p>
  <strong>Is active:</strong>
  <%= @laptop.is_active %>
</p>

<%= link_to 'Edit', edit_laptop_path(@laptop) %> |
<%= link_to 'Back', laptops_path %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>RoRBinar</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>